<?php

namespace CfcalSasieSDK;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ObjetPublicBase' => '\\CfcalSasieSDK\\Entity\\ObjetPublicBase',
            'ObjetPublicSaisieEnLigneBase' => '\\CfcalSasieSDK\\Entity\\ObjetPublicSaisieEnLigneBase',
            'ResultatAppelWebservice' => '\\CfcalSasieSDK\\Entity\\ResultatAppelWebservice',
            'ResultatOperationPublicBase' => '\\CfcalSasieSDK\\Entity\\ResultatOperationPublicBase',
            'ObjetPublicOutilsBase' => '\\CfcalSasieSDK\\Entity\\ObjetPublicOutilsBase',
            'ArrayOfMessage' => '\\CfcalSasieSDK\\ArrayType\\ArrayOfMessage',
            'Message' => '\\CfcalSasieSDK\\Entity\\Message',
            'SaisieEnligne' => '\\CfcalSasieSDK\\Entity\\SaisieEnligne',
            'SectionSystemeExpert' => '\\CfcalSasieSDK\\Entity\\SectionSystemeExpert',
            'SectionEmprunteurs' => '\\CfcalSasieSDK\\Entity\\SectionEmprunteurs',
            'Emprunteurs' => '\\CfcalSasieSDK\\Entity\\Emprunteurs',
            'Emprunteur' => '\\CfcalSasieSDK\\Entity\\Emprunteur',
            'Ville' => '\\CfcalSasieSDK\\Entity\\Ville',
            'Contacts' => '\\CfcalSasieSDK\\Entity\\Contacts',
            'Contact' => '\\CfcalSasieSDK\\Entity\\Contact',
            'PersonneACharges' => '\\CfcalSasieSDK\\Entity\\PersonneACharges',
            'PersonneACharge' => '\\CfcalSasieSDK\\Entity\\PersonneACharge',
            'Emplois' => '\\CfcalSasieSDK\\Entity\\Emplois',
            'Emploi' => '\\CfcalSasieSDK\\Entity\\Emploi',
            'Societe' => '\\CfcalSasieSDK\\Entity\\Societe',
            'Revenus' => '\\CfcalSasieSDK\\Entity\\Revenus',
            'Revenu' => '\\CfcalSasieSDK\\Entity\\Revenu',
            'Charges' => '\\CfcalSasieSDK\\Entity\\Charges',
            'Charge' => '\\CfcalSasieSDK\\Entity\\Charge',
            'Assurance' => '\\CfcalSasieSDK\\Entity\\Assurance',
            'Liens' => '\\CfcalSasieSDK\\Entity\\Liens',
            'Lien' => '\\CfcalSasieSDK\\Entity\\Lien',
            'SCI' => '\\CfcalSasieSDK\\Entity\\SCI',
            'SectionEmpruntsEtDettes' => '\\CfcalSasieSDK\\Entity\\SectionEmpruntsEtDettes',
            'Emprunts' => '\\CfcalSasieSDK\\Entity\\Emprunts',
            'Emprunt' => '\\CfcalSasieSDK\\Entity\\Emprunt',
            'Dettes' => '\\CfcalSasieSDK\\Entity\\Dettes',
            'Dette' => '\\CfcalSasieSDK\\Entity\\Dette',
            'SectionCompteBancaire' => '\\CfcalSasieSDK\\Entity\\SectionCompteBancaire',
            'IBAN' => '\\CfcalSasieSDK\\Entity\\IBAN',
            'SectionCautionsHypothecaires' => '\\CfcalSasieSDK\\Entity\\SectionCautionsHypothecaires',
            'CautionsHypothecaires' => '\\CfcalSasieSDK\\Entity\\CautionsHypothecaires',
            'CautionHypothecaire' => '\\CfcalSasieSDK\\Entity\\CautionHypothecaire',
            'SectionGaranties' => '\\CfcalSasieSDK\\Entity\\SectionGaranties',
            'Garanties' => '\\CfcalSasieSDK\\Entity\\Garanties',
            'Garantie' => '\\CfcalSasieSDK\\Entity\\Garantie',
            'Biens' => '\\CfcalSasieSDK\\Entity\\Biens',
            'Bien' => '\\CfcalSasieSDK\\Entity\\Bien',
            'PrixAcquisitionBien' => '\\CfcalSasieSDK\\Entity\\PrixAcquisitionBien',
            'EstimationRecenteBien' => '\\CfcalSasieSDK\\Entity\\EstimationRecenteBien',
            'DescriptionBiens' => '\\CfcalSasieSDK\\Entity\\DescriptionBiens',
            'DescriptionBien' => '\\CfcalSasieSDK\\Entity\\DescriptionBien',
            'CoproprieteBiens' => '\\CfcalSasieSDK\\Entity\\CoproprieteBiens',
            'CoproprieteBien' => '\\CfcalSasieSDK\\Entity\\CoproprieteBien',
            'Proprietaires' => '\\CfcalSasieSDK\\Entity\\Proprietaires',
            'Proprietaire' => '\\CfcalSasieSDK\\Entity\\Proprietaire',
            'ReferenceCadastrales' => '\\CfcalSasieSDK\\Entity\\ReferenceCadastrales',
            'ReferenceCadastrale' => '\\CfcalSasieSDK\\Entity\\ReferenceCadastrale',
            'SectionIntermediaires' => '\\CfcalSasieSDK\\Entity\\SectionIntermediaires',
            'SectionNotaire' => '\\CfcalSasieSDK\\Entity\\SectionNotaire',
            'SectionSignature' => '\\CfcalSasieSDK\\Entity\\SectionSignature',
            'SignatureEmprunteurs' => '\\CfcalSasieSDK\\Entity\\SignatureEmprunteurs',
            'SignatureEmprunteur' => '\\CfcalSasieSDK\\Entity\\SignatureEmprunteur',
            'SectionAcquisitions' => '\\CfcalSasieSDK\\Entity\\SectionAcquisitions',
            'Acquisitions' => '\\CfcalSasieSDK\\Entity\\Acquisitions',
            'Acquisition' => '\\CfcalSasieSDK\\Entity\\Acquisition',
            'SectionFinancements' => '\\CfcalSasieSDK\\Entity\\SectionFinancements',
            'Financements' => '\\CfcalSasieSDK\\Entity\\Financements',
            'Financement' => '\\CfcalSasieSDK\\Entity\\Financement',
            'SectionCautions' => '\\CfcalSasieSDK\\Entity\\SectionCautions',
            'Cautions' => '\\CfcalSasieSDK\\Entity\\Cautions',
            'Caution' => '\\CfcalSasieSDK\\Entity\\Caution',
            'SectionLienPersonnePhysiqueEtPersonneMorales' => '\\CfcalSasieSDK\\Entity\\SectionLienPersonnePhysiqueEtPersonneMorales',
            'LienPersonnePhysiqueEtPersonneMorales' => '\\CfcalSasieSDK\\Entity\\LienPersonnePhysiqueEtPersonneMorales',
            'LienPersonnePhysiqueEtPersonneMorale' => '\\CfcalSasieSDK\\Entity\\LienPersonnePhysiqueEtPersonneMorale',
            'ResultatValidationSaisieEnLigne' => '\\CfcalSasieSDK\\Entity\\ResultatValidationSaisieEnLigne',
            'ResultatValidationEtEnregistrementSaisieEnLigne' => '\\CfcalSasieSDK\\Entity\\ResultatValidationEtEnregistrementSaisieEnLigne',
            'InformationsAjoutPieceDansSaisieEnLigne' => '\\CfcalSasieSDK\\Entity\\InformationsAjoutPieceDansSaisieEnLigne',
            'Piece' => '\\CfcalSasieSDK\\Entity\\Piece',
            'ResultatAjoutPieceDansSaisieEnLigne' => '\\CfcalSasieSDK\\Entity\\ResultatAjoutPieceDansSaisieEnLigne',
            'InformationsListeDocumentSaisieEnLigne' => '\\CfcalSasieSDK\\Entity\\InformationsListeDocumentSaisieEnLigne',
            'ResultatListeDocumentSaisieEnLigne' => '\\CfcalSasieSDK\\Entity\\ResultatListeDocumentSaisieEnLigne',
            'DocumentInformations' => '\\CfcalSasieSDK\\Entity\\DocumentInformations',
            'DocumentInformation' => '\\CfcalSasieSDK\\Entity\\DocumentInformation',
            'InformationsGenerationDocumentSaisieEnLigne' => '\\CfcalSasieSDK\\Entity\\InformationsGenerationDocumentSaisieEnLigne',
            'ResultatGenerationDocumentSaisieEnLigne' => '\\CfcalSasieSDK\\Entity\\ResultatGenerationDocumentSaisieEnLigne',
            'Document' => '\\CfcalSasieSDK\\Entity\\Document',
            'InformationsIntegrationSaisieEnLigne' => '\\CfcalSasieSDK\\Entity\\InformationsIntegrationSaisieEnLigne',
            'ResultatIntegrationSaisieEnLigne' => '\\CfcalSasieSDK\\Entity\\ResultatIntegrationSaisieEnLigne',
            'InformationsEtatSaisieEnLigne' => '\\CfcalSasieSDK\\Entity\\InformationsEtatSaisieEnLigne',
            'ResultatEtatSaisieEnLigne' => '\\CfcalSasieSDK\\Entity\\ResultatEtatSaisieEnLigne',
            'DetailEtatSaisieEnLigne' => '\\CfcalSasieSDK\\Entity\\DetailEtatSaisieEnLigne',
            'RenvoyerResultatValidationSaisieEnLigne' => '\\CfcalSasieSDK\\Entity\\RenvoyerResultatValidationSaisieEnLigne',
            'RenvoyerResultatValidationSaisieEnLigneResponse' => '\\CfcalSasieSDK\\Entity\\RenvoyerResultatValidationSaisieEnLigneResponse',
            'RenvoyerResultatValidationEtEnregistrementSaisieEnLigne' => '\\CfcalSasieSDK\\Entity\\RenvoyerResultatValidationEtEnregistrementSaisieEnLigne',
            'RenvoyerResultatValidationEtEnregistrementSaisieEnLigneResponse' => '\\CfcalSasieSDK\\Entity\\RenvoyerResultatValidationEtEnregistrementSaisieEnLigneResponse',
            'AjouterPieceDansSaisieEnLigne' => '\\CfcalSasieSDK\\Entity\\AjouterPieceDansSaisieEnLigne',
            'AjouterPieceDansSaisieEnLigneResponse' => '\\CfcalSasieSDK\\Entity\\AjouterPieceDansSaisieEnLigneResponse',
            'RenvoyerListeDocumentSaisieEnLigne' => '\\CfcalSasieSDK\\Entity\\RenvoyerListeDocumentSaisieEnLigne',
            'RenvoyerListeDocumentSaisieEnLigneResponse' => '\\CfcalSasieSDK\\Entity\\RenvoyerListeDocumentSaisieEnLigneResponse',
            'RenvoyerDocumentSaisieEnLigne' => '\\CfcalSasieSDK\\Entity\\RenvoyerDocumentSaisieEnLigne',
            'RenvoyerDocumentSaisieEnLigneResponse' => '\\CfcalSasieSDK\\Entity\\RenvoyerDocumentSaisieEnLigneResponse',
            'RenvoyerResultatIntegrationSaisieEnLigne' => '\\CfcalSasieSDK\\Entity\\RenvoyerResultatIntegrationSaisieEnLigne',
            'RenvoyerResultatIntegrationSaisieEnLigneResponse' => '\\CfcalSasieSDK\\Entity\\RenvoyerResultatIntegrationSaisieEnLigneResponse',
            'RenvoyerEtatSaisieEnLigne' => '\\CfcalSasieSDK\\Entity\\RenvoyerEtatSaisieEnLigne',
            'RenvoyerEtatSaisieEnLigneResponse' => '\\CfcalSasieSDK\\Entity\\RenvoyerEtatSaisieEnLigneResponse',
            'ExceptionWCF' => '\\CfcalSasieSDK\\Entity\\ExceptionWCF',
        );
    }
}
