<?php

namespace CfcalSasieSDK\Entity;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Biens Entity
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Biens
 * @subpackage Structs
 */
class Biens extends AbstractStructBase
{
    /**
     * The Bien
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CfcalSasieSDK\Entity\Bien[]
     */
    public $Bien;
    /**
     * Constructor method for Biens
     * @uses Biens::setBien()
     * @param \CfcalSasieSDK\Entity\Bien[] $bien
     */
    public function __construct(array $bien = array())
    {
        $this
            ->setBien($bien);
    }
    /**
     * Get Bien value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CfcalSasieSDK\Entity\Bien[]|null
     */
    public function getBien()
    {
        return isset($this->Bien) ? $this->Bien : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBien method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBien method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBienForArrayConstraintsFromSetBien(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $biensBienItem) {
            // validation for constraint: itemType
            if (!$biensBienItem instanceof \CfcalSasieSDK\Entity\Bien) {
                $invalidValues[] = is_object($biensBienItem) ? get_class($biensBienItem) : sprintf('%s(%s)', gettype($biensBienItem), var_export($biensBienItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Bien property can only contain items of type \CfcalSasieSDK\Entity\Bien, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Bien value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CfcalSasieSDK\Entity\Bien[] $bien
     * @return \CfcalSasieSDK\Entity\Biens
     */
    public function setBien(array $bien = array())
    {
        // validation for constraint: array
        if ('' !== ($bienArrayErrorMessage = self::validateBienForArrayConstraintsFromSetBien($bien))) {
            throw new \InvalidArgumentException($bienArrayErrorMessage, __LINE__);
        }
        if (is_null($bien) || (is_array($bien) && empty($bien))) {
            unset($this->Bien);
        } else {
            $this->Bien = $bien;
        }
        return $this;
    }
    /**
     * Add item to Bien value
     * @throws \InvalidArgumentException
     * @param \CfcalSasieSDK\Entity\Bien $item
     * @return \CfcalSasieSDK\Entity\Biens
     */
    public function addToBien(\CfcalSasieSDK\Entity\Bien $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CfcalSasieSDK\Entity\Bien) {
            throw new \InvalidArgumentException(sprintf('The Bien property can only contain items of type \CfcalSasieSDK\Entity\Bien, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Bien[] = $item;
        return $this;
    }
}
