<?php

namespace CfcalSasieSDK\Entity;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReferenceCadastrales Entity
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ReferenceCadastrales
 * @subpackage Structs
 */
class ReferenceCadastrales extends AbstractStructBase
{
    /**
     * The ReferenceCadastrale
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CfcalSasieSDK\Entity\ReferenceCadastrale[]
     */
    public $ReferenceCadastrale;
    /**
     * Constructor method for ReferenceCadastrales
     * @uses ReferenceCadastrales::setReferenceCadastrale()
     * @param \CfcalSasieSDK\Entity\ReferenceCadastrale[] $referenceCadastrale
     */
    public function __construct(array $referenceCadastrale = array())
    {
        $this
            ->setReferenceCadastrale($referenceCadastrale);
    }
    /**
     * Get ReferenceCadastrale value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CfcalSasieSDK\Entity\ReferenceCadastrale[]|null
     */
    public function getReferenceCadastrale()
    {
        return isset($this->ReferenceCadastrale) ? $this->ReferenceCadastrale : null;
    }
    /**
     * This method is responsible for validating the values passed to the setReferenceCadastrale method
     * This method is willingly generated in order to preserve the one-line inline validation within the setReferenceCadastrale method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateReferenceCadastraleForArrayConstraintsFromSetReferenceCadastrale(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $referenceCadastralesReferenceCadastraleItem) {
            // validation for constraint: itemType
            if (!$referenceCadastralesReferenceCadastraleItem instanceof \CfcalSasieSDK\Entity\ReferenceCadastrale) {
                $invalidValues[] = is_object($referenceCadastralesReferenceCadastraleItem) ? get_class($referenceCadastralesReferenceCadastraleItem) : sprintf('%s(%s)', gettype($referenceCadastralesReferenceCadastraleItem), var_export($referenceCadastralesReferenceCadastraleItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ReferenceCadastrale property can only contain items of type \CfcalSasieSDK\Entity\ReferenceCadastrale, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ReferenceCadastrale value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CfcalSasieSDK\Entity\ReferenceCadastrale[] $referenceCadastrale
     * @return \CfcalSasieSDK\Entity\ReferenceCadastrales
     */
    public function setReferenceCadastrale(array $referenceCadastrale = array())
    {
        // validation for constraint: array
        if ('' !== ($referenceCadastraleArrayErrorMessage = self::validateReferenceCadastraleForArrayConstraintsFromSetReferenceCadastrale($referenceCadastrale))) {
            throw new \InvalidArgumentException($referenceCadastraleArrayErrorMessage, __LINE__);
        }
        if (is_null($referenceCadastrale) || (is_array($referenceCadastrale) && empty($referenceCadastrale))) {
            unset($this->ReferenceCadastrale);
        } else {
            $this->ReferenceCadastrale = $referenceCadastrale;
        }
        return $this;
    }
    /**
     * Add item to ReferenceCadastrale value
     * @throws \InvalidArgumentException
     * @param \CfcalSasieSDK\Entity\ReferenceCadastrale $item
     * @return \CfcalSasieSDK\Entity\ReferenceCadastrales
     */
    public function addToReferenceCadastrale(\CfcalSasieSDK\Entity\ReferenceCadastrale $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CfcalSasieSDK\Entity\ReferenceCadastrale) {
            throw new \InvalidArgumentException(sprintf('The ReferenceCadastrale property can only contain items of type \CfcalSasieSDK\Entity\ReferenceCadastrale, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ReferenceCadastrale[] = $item;
        return $this;
    }
}
