<?php

namespace CfcalSasieSDK\Entity;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SignatureEmprunteurs Entity
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SignatureEmprunteurs
 * @subpackage Structs
 */
class SignatureEmprunteurs extends AbstractStructBase
{
    /**
     * The SignatureEmprunteur
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CfcalSasieSDK\Entity\SignatureEmprunteur[]
     */
    public $SignatureEmprunteur;
    /**
     * Constructor method for SignatureEmprunteurs
     * @uses SignatureEmprunteurs::setSignatureEmprunteur()
     * @param \CfcalSasieSDK\Entity\SignatureEmprunteur[] $signatureEmprunteur
     */
    public function __construct(array $signatureEmprunteur = array())
    {
        $this
            ->setSignatureEmprunteur($signatureEmprunteur);
    }
    /**
     * Get SignatureEmprunteur value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CfcalSasieSDK\Entity\SignatureEmprunteur[]|null
     */
    public function getSignatureEmprunteur()
    {
        return isset($this->SignatureEmprunteur) ? $this->SignatureEmprunteur : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSignatureEmprunteur method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSignatureEmprunteur method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSignatureEmprunteurForArrayConstraintsFromSetSignatureEmprunteur(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $signatureEmprunteursSignatureEmprunteurItem) {
            // validation for constraint: itemType
            if (!$signatureEmprunteursSignatureEmprunteurItem instanceof \CfcalSasieSDK\Entity\SignatureEmprunteur) {
                $invalidValues[] = is_object($signatureEmprunteursSignatureEmprunteurItem) ? get_class($signatureEmprunteursSignatureEmprunteurItem) : sprintf('%s(%s)', gettype($signatureEmprunteursSignatureEmprunteurItem), var_export($signatureEmprunteursSignatureEmprunteurItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SignatureEmprunteur property can only contain items of type \CfcalSasieSDK\Entity\SignatureEmprunteur, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SignatureEmprunteur value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CfcalSasieSDK\Entity\SignatureEmprunteur[] $signatureEmprunteur
     * @return \CfcalSasieSDK\Entity\SignatureEmprunteurs
     */
    public function setSignatureEmprunteur(array $signatureEmprunteur = array())
    {
        // validation for constraint: array
        if ('' !== ($signatureEmprunteurArrayErrorMessage = self::validateSignatureEmprunteurForArrayConstraintsFromSetSignatureEmprunteur($signatureEmprunteur))) {
            throw new \InvalidArgumentException($signatureEmprunteurArrayErrorMessage, __LINE__);
        }
        if (is_null($signatureEmprunteur) || (is_array($signatureEmprunteur) && empty($signatureEmprunteur))) {
            unset($this->SignatureEmprunteur);
        } else {
            $this->SignatureEmprunteur = $signatureEmprunteur;
        }
        return $this;
    }
    /**
     * Add item to SignatureEmprunteur value
     * @throws \InvalidArgumentException
     * @param \CfcalSasieSDK\Entity\SignatureEmprunteur $item
     * @return \CfcalSasieSDK\Entity\SignatureEmprunteurs
     */
    public function addToSignatureEmprunteur(\CfcalSasieSDK\Entity\SignatureEmprunteur $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CfcalSasieSDK\Entity\SignatureEmprunteur) {
            throw new \InvalidArgumentException(sprintf('The SignatureEmprunteur property can only contain items of type \CfcalSasieSDK\Entity\SignatureEmprunteur, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SignatureEmprunteur[] = $item;
        return $this;
    }
}
