<?php

namespace CfcalSasieSDK\Service;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Renvoyer Service
 * @subpackage Services
 */
class Renvoyer extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named
     * RenvoyerResultatValidationSaisieEnLigne
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \CfcalSasieSDK\Entity\RenvoyerResultatValidationSaisieEnLigne $parameters
     * @return \CfcalSasieSDK\Entity\RenvoyerResultatValidationSaisieEnLigneResponse|bool
     */
    public function RenvoyerResultatValidationSaisieEnLigne(\CfcalSasieSDK\Entity\RenvoyerResultatValidationSaisieEnLigne $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->RenvoyerResultatValidationSaisieEnLigne($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * RenvoyerResultatValidationEtEnregistrementSaisieEnLigne
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \CfcalSasieSDK\Entity\RenvoyerResultatValidationEtEnregistrementSaisieEnLigne $parameters
     * @return \CfcalSasieSDK\Entity\RenvoyerResultatValidationEtEnregistrementSaisieEnLigneResponse|bool
     */
    public function RenvoyerResultatValidationEtEnregistrementSaisieEnLigne(\CfcalSasieSDK\Entity\RenvoyerResultatValidationEtEnregistrementSaisieEnLigne $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->RenvoyerResultatValidationEtEnregistrementSaisieEnLigne($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named RenvoyerListeDocumentSaisieEnLigne
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \CfcalSasieSDK\Entity\RenvoyerListeDocumentSaisieEnLigne $parameters
     * @return \CfcalSasieSDK\Entity\RenvoyerListeDocumentSaisieEnLigneResponse|bool
     */
    public function RenvoyerListeDocumentSaisieEnLigne(\CfcalSasieSDK\Entity\RenvoyerListeDocumentSaisieEnLigne $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->RenvoyerListeDocumentSaisieEnLigne($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named RenvoyerDocumentSaisieEnLigne
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \CfcalSasieSDK\Entity\RenvoyerDocumentSaisieEnLigne $parameters
     * @return \CfcalSasieSDK\Entity\RenvoyerDocumentSaisieEnLigneResponse|bool
     */
    public function RenvoyerDocumentSaisieEnLigne(\CfcalSasieSDK\Entity\RenvoyerDocumentSaisieEnLigne $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->RenvoyerDocumentSaisieEnLigne($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * RenvoyerResultatIntegrationSaisieEnLigne
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \CfcalSasieSDK\Entity\RenvoyerResultatIntegrationSaisieEnLigne $parameters
     * @return \CfcalSasieSDK\Entity\RenvoyerResultatIntegrationSaisieEnLigneResponse|bool
     */
    public function RenvoyerResultatIntegrationSaisieEnLigne(\CfcalSasieSDK\Entity\RenvoyerResultatIntegrationSaisieEnLigne $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->RenvoyerResultatIntegrationSaisieEnLigne($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named RenvoyerEtatSaisieEnLigne
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \CfcalSasieSDK\Entity\RenvoyerEtatSaisieEnLigne $parameters
     * @return \CfcalSasieSDK\Entity\RenvoyerEtatSaisieEnLigneResponse|bool
     */
    public function RenvoyerEtatSaisieEnLigne(\CfcalSasieSDK\Entity\RenvoyerEtatSaisieEnLigne $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->RenvoyerEtatSaisieEnLigne($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \CfcalSasieSDK\Entity\RenvoyerDocumentSaisieEnLigneResponse|\CfcalSasieSDK\Entity\RenvoyerEtatSaisieEnLigneResponse|\CfcalSasieSDK\Entity\RenvoyerListeDocumentSaisieEnLigneResponse|\CfcalSasieSDK\Entity\RenvoyerResultatIntegrationSaisieEnLigneResponse|\CfcalSasieSDK\Entity\RenvoyerResultatValidationEtEnregistrementSaisieEnLigneResponse|\CfcalSasieSDK\Entity\RenvoyerResultatValidationSaisieEnLigneResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
